/*******************************************************************************
 * EngineTypes generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class EngineTypes extends Object
    abstract
    native;

enum EPathFindingError
{
    PATHERROR_STARTPOLYNOTFOUND,
    PATHERROR_GOALPOLYNOTFOUND,
    PATHERROR_ANCHORPYLONNOTFOUND,
    PATHERROR_NOPATHFOUND,
    PATHERROR_COMPUTEVALIDFINALDEST_FAIL,
    PATHERROR_GETNEXTMOVELOCATION_FAIL,
    PATHERROR_MOVETIMEOUT,
    PATHERROR_MAX
};

enum EBlendMode
{
    BLEND_Opaque,
    BLEND_Masked,
    BLEND_Translucent,
    BLEND_Additive,
    BLEND_Modulate,
    BLEND_ModulateAndAdd,
    BLEND_SoftMasked,
    BLEND_AlphaComposite,
    BLEND_DitheredTranslucent,
    BLEND_MAX
};

enum EMaterialLightingModel
{
    MLM_Phong,
    MLM_NonDirectional,
    MLM_Unlit,
    MLM_SHPRT,
    MLM_Custom,
    MLM_Anisotropic,
    MLM_MAX
};

enum EMaterialTessellationMode
{
    MTM_NoTessellation,
    MTM_FlatTessellation,
    MTM_PNTriangles,
    MTM_MAX
};

enum EMobileValueSource
{
    MVS_Constant,
    MVS_VertexColorRed,
    MVS_VertexColorGreen,
    MVS_VertexColorBlue,
    MVS_VertexColorAlpha,
    MVS_BaseTextureRed,
    MVS_BaseTextureGreen,
    MVS_BaseTextureBlue,
    MVS_BaseTextureAlpha,
    MVS_MaskTextureRed,
    MVS_MaskTextureGreen,
    MVS_MaskTextureBlue,
    MVS_MaskTextureAlpha,
    MVS_NormalTextureAlpha,
    MVS_EmissiveTextureRed,
    MVS_EmissiveTextureGreen,
    MVS_EmissiveTextureBlue,
    MVS_EmissiveTextureAlpha,
    MVS_MAX
};

enum EMobileTextureBlendFactorSource
{
    MTBFS_VertexColor,
    MTBFS_MaskTexture,
    MTBFS_MAX
};

enum EMobileTexCoordsSource
{
    MTCS_TexCoords0,
    MTCS_TexCoords1,
    MTCS_TexCoords2,
    MTCS_TexCoords3,
    MTCS_MAX
};

enum EMobileAlphaValueSource
{
    MAVS_DiffuseTextureAlpha,
    MAVS_MaskTextureRed,
    MAVS_MaskTextureGreen,
    MAVS_MaskTextureBlue,
    MAVS_MAX
};

enum EMobileColorMultiplySource
{
    MCMS_None,
    MCMS_BaseTextureRed,
    MCMS_BaseTextureGreen,
    MCMS_BaseTextureBlue,
    MCMS_BaseTextureAlpha,
    MCMS_MaskTextureRed,
    MCMS_MaskTextureGreen,
    MCMS_MaskTextureBlue,
    MCMS_MaskTextureAlpha,
    MCMS_MAX
};

enum EMobileEmissiveColorSource
{
    MECS_EmissiveTexture,
    MECS_BaseTexture,
    MECS_Constant,
    MECS_MAX
};

enum EMobileEnvironmentBlendMode
{
    MEBM_Add,
    MEBM_Lerp,
    MEBM_MAX
};

enum EMobileSpecularMask
{
    MSM_Constant,
    MSM_Luminance,
    MSM_DiffuseRed,
    MSM_DiffuseGreen,
    MSM_DiffuseBlue,
    MSM_DiffuseAlpha,
    MSM_MaskTextureRGB,
    MSM_MaskTextureRed,
    MSM_MaskTextureGreen,
    MSM_MaskTextureBlue,
    MSM_MaskTextureAlpha,
    MSM_MAX
};

enum EMobileAmbientOcclusionSource
{
    MAOS_Disabled,
    MAOS_VertexColorRed,
    MAOS_VertexColorGreen,
    MAOS_VertexColorBlue,
    MAOS_VertexColorAlpha,
    MAOS_MAX
};

enum ELightingBuildQuality
{
    Quality_Preview,
    Quality_Medium,
    Quality_High,
    Quality_Production,
    Quality_NoGlobalIllumination,
    Quality_MAX
};

struct native SubtitleCue
{
    var() const localized string Text;
    var() const localized float Time;

    structdefaultproperties
    {
        Text=""
        Time=0.0
    }
};

struct native LocalizedSubtitle
{
    var string LanguageExt;
    var array<SubtitleCue> Subtitles;
    var bool bMature;
    var bool bManualWordWrap;
    var bool bSingleLine;

    structdefaultproperties
    {
        LanguageExt=""
        Subtitles=none
        bMature=false
        bManualWordWrap=false
        bSingleLine=false
    }
};

struct LightMapRef
{
    var private native const Pointer Reference;
};

struct native DominantShadowInfo
{
    var Matrix WorldToLight;
    var Matrix LightToWorld;
    var Box LightSpaceImportanceBounds;
    var int ShadowMapSizeX;
    var int ShadowMapSizeY;

    structdefaultproperties
    {
        WorldToLight=(XPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),YPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),ZPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),WPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0))
        LightToWorld=(XPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),YPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),ZPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),WPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0))
        LightSpaceImportanceBounds=(Min=(X=0.0,Y=0.0,Z=0.0),Max=(X=0.0,Y=0.0,Z=0.0),IsValid=0)
        ShadowMapSizeX=0
        ShadowMapSizeY=0
    }
};

struct native LightmassLightSettings
{
    var(General) float IndirectLightingScale;
    var(General) float IndirectLightingSaturation;
    var(General) float ShadowExponent;

    structdefaultproperties
    {
        IndirectLightingScale=1.0
        IndirectLightingSaturation=1.0
        ShadowExponent=2.0
    }
};

struct native LightmassPointLightSettings extends LightmassLightSettings
{
    var(Point) float LightSourceRadius;

    structdefaultproperties
    {
        LightSourceRadius=100.0
        IndirectLightingScale=0.0
        IndirectLightingSaturation=0.0
        ShadowExponent=0.0
    }
};

struct native LightmassDirectionalLightSettings extends LightmassLightSettings
{
    var(Directional) float LightSourceAngle;

    structdefaultproperties
    {
        LightSourceAngle=3.0
        IndirectLightingScale=0.0
        IndirectLightingSaturation=0.0
        ShadowExponent=0.0
    }
};

struct LightmassPrimitiveSettings
{
    var() bool bUseTwoSidedLighting;
    var() bool bShadowIndirectOnly;
    var() bool bUseEmissiveForStaticLighting;
    var() float EmissiveLightFalloffExponent;
    var() float EmissiveLightExplicitInfluenceRadius;
    var() float EmissiveBoost;
    var() float DiffuseBoost;
    var float SpecularBoost;
    var() float FullyOccludedSamplesFraction;

    structdefaultproperties
    {
        bUseTwoSidedLighting=false
        bShadowIndirectOnly=false
        bUseEmissiveForStaticLighting=false
        EmissiveLightFalloffExponent=2.0
        EmissiveLightExplicitInfluenceRadius=0.0
        EmissiveBoost=1.0
        DiffuseBoost=1.0
        SpecularBoost=1.0
        FullyOccludedSamplesFraction=1.0
    }
};

struct native LightmassDebugOptions
{
    var() bool bDebugMode;
    var() bool bStatsEnabled;
    var() bool bGatherBSPSurfacesAcrossComponents;
    var() float CoplanarTolerance;
    var() bool bUseDeterministicLighting;
    var() bool bUseImmediateImport;
    var() bool bImmediateProcessMappings;
    var() bool bSortMappings;
    var() bool bDumpBinaryFiles;
    var() bool bDebugMaterials;
    var() bool bPadMappings;
    var() bool bDebugPaddings;
    var() bool bOnlyCalcDebugTexelMappings;
    var() bool bUseRandomColors;
    var() bool bColorBordersGreen;
    var() bool bColorByExecutionTime;
    var() float ExecutionTimeDivisor;
    var bool bInitialized;

    structdefaultproperties
    {
        bDebugMode=false
        bStatsEnabled=false
        bGatherBSPSurfacesAcrossComponents=true
        CoplanarTolerance=0.0010
        bUseDeterministicLighting=true
        bUseImmediateImport=true
        bImmediateProcessMappings=true
        bSortMappings=true
        bDumpBinaryFiles=false
        bDebugMaterials=false
        bPadMappings=true
        bDebugPaddings=false
        bOnlyCalcDebugTexelMappings=false
        bUseRandomColors=false
        bColorBordersGreen=false
        bColorByExecutionTime=false
        ExecutionTimeDivisor=15.0
        bInitialized=false
    }
};

struct native SwarmDebugOptions
{
    var() bool bDistributionEnabled;
    var() bool bForceContentExport;
    var bool bInitialized;

    structdefaultproperties
    {
        bDistributionEnabled=true
        bForceContentExport=false
        bInitialized=false
    }
};

struct native RootMotionCurve
{
    var() name AnimName;
    var() InterpCurveVector Curve;
    var() float MaxCurveTime;

    structdefaultproperties
    {
        AnimName=None
        Curve=(Points=none,InterpMethod=EInterpMethodType.IMT_UseFixedTangentEvalAndNewAutoTangents)
        MaxCurveTime=0.0
    }
};

struct native PrimitiveMaterialRef
{
    var export editinline PrimitiveComponent Primitive;
    var int MaterialIndex;

    structdefaultproperties
    {
        Primitive=none
        MaterialIndex=0
    }
};

struct native PostProcessMaterialRef
{
    var MaterialEffect Effect;

    structdefaultproperties
    {
        Effect=none
    }
};

struct native MaterialReferenceList
{
    var() MaterialInterface TargetMaterial;
    var edithide array<PrimitiveMaterialRef> AffectedMaterialRefs;
    var edithide array<PostProcessMaterialRef> AffectedPPChainMaterialRefs;

    structdefaultproperties
    {
        TargetMaterial=none
        AffectedMaterialRefs=none
        AffectedPPChainMaterialRefs=none
    }
};

struct native VelocityObstacleStat
{
    var Vector Position;
    var Vector Velocity;
    var float Radius;
    var int Priority;

    structdefaultproperties
    {
        Position=(X=0.0,Y=0.0,Z=0.0)
        Velocity=(X=0.0,Y=0.0,Z=0.0)
        Radius=0.0
        Priority=0
    }
};
